@REM = '--*-PERL-*--';
@REM = '
@ECHO OFF
ECHO ### Namazu for Win32 auto setting program.
START PERL.EXE -v
IF ERRORLEVEL 1 GOTO PERLNOTFOUND

IF NOT EXIST namazu\NMZSETUP.BAT GOTO CURRENTEXECUTE
PERL.EXE namazu\NMZSETUP.BAT %1 %2 %3 %4 %5 %6 %7 %8 %9
GOTO MODIFIED

:CURRENTEXECUTE
PERL.EXE NMZSETUP.BAT %1 %2 %3 %4 %5 %6 %7 %8 %9

:MODIFIED
IF ERRORLEVEL 1 GOTO CANNOTOPEN
ECHO   Modify complete !!!

:DISPREADME
IF NOT EXIST README.TXT GOTO NOREADMETXT
START .\README.txt
GOTO END

:NOREADMETXT
START .\namazu\README.txt
GOTO END

@rem ';
#my ($perlv) = grep(/perl[^\d]*(\d\.\d\.?\d\.?\d)/, `perl -v`);
#($perlv) = $perlv =~ /perl[^\d]*(\d\.(\d\.?)+)/;
#$perlv =~ s/\.//;

require 5.003;
use Cwd;
use File::Find;
use Win32API::Registry 0.13 qw( :ALL );

my $installdir = getcwd();
$installdir =~ s/\//\\/g;
$installdir =~ s/\\namazu$|\\$//mi;
my ($homedrive) = $ENV{'windir'} =~ m/^(\w\:).*/;
my ($dictdir) = grep(/kakasi/i, split(/;/, $ENV{'PATH'}));
if ($dictdir eq '') {
    $dictdir = "$homedrive\\kakasi\\share\\kakasi";
} else {
    my $cwd = getcwd()."\\";
    $dictdir =~ s/\\bin$//i;
    find(sub {$dictdir=$File::Find::dir,return if /kanwadict/;}, "$dictdir");
    $dictdir =~ s/\//\\/g;
    chdir ("$cwd");
}

my @scripts = ('mknmz','gcnmz','mailutime','vfnmz','kwnmz','nmzgrep','bnamazu','rfnmz');
my $autoexecfile      = $homedrive.'\AUTOEXEC.BAT';
#my $configfile        = $homedrive.'\CONFIG.SYS';
my $pathstring;
my $path              = $installdir.'\namazu\bin';
my $batpath           = $installdir.'\namazu\bin';
my $namazulocaledir   = $installdir.'\namazu\share\locale';
my $namazurc          = $installdir.'\namazu\etc\namazu\namazurc';
my $namazurcpath      = $installdir.'\namazu\etc\namazu\namazurc';
my $indexpath         = $installdir.'\namazu\var\namazu\index';
my $templatepath      = $installdir.'\namazu\share\namazu\template';
my $mknmzrc           = $installdir.'\namazu\etc\namazu\mknmzrc';
my $mknmzrcpath       = $installdir.'\namazu\etc\namazu\mknmzrc';
my $confdirpath       = $installdir.'\namazu\etc\namazu';
my $libdirpath        = $installdir.'\namazu\share\namazu\pl';
my $filterdirpath     = $installdir.'\namazu\share\namazu\filter';
my $templatedirpath   = $installdir.'\namazu\share\namazu\template';
my $kanwadictpath     = $dictdir.'\kanwadict';
my $itaijidictpath    = $dictdir.'\itaijidict';
my $home              = $installdir.'\namazu';
my $locale;
my $lang;
Win32API::Registry::RegOpenKeyEx ( HKEY_USERS,
    '.DEFAULT\Control Panel\International',
    NULL, KEY_ALL_ACCESS, $hkey ) || exit(1);
Win32API::Registry::RegQueryValueEx( $hkey, 'Locale', [], $type,
    $locale, [] );
    if ($locale == "00000411") {
        $lang = 'ja_JP.SJIS';
        $ENV{'LOCALE'} = 'ja'
    } else {
        $lang = 'C';
        $ENV{'LOCALE'} = 'en'
    }

    if (open(AUTOEXEC,"<$autoexecfile")) {
    while (<AUTOEXEC>) {
        if (m/.*REM !!! DO NOT MODIFY !!!/i){
            print "\"REM !!! DO NOT MODIFY !!!\" found in AUTOEXEC.BAT. Exit now!!\n\n";
            exit(0);
        }
    }
    close (AUTOEXEC);
    }

print <<'--end--';
This install script assumes that you have unpacked 
Namazu for Win32 into the final intended destination 
directory.
Do you wish to proceed? [Y/n]
--end--

my $in = <STDIN>;
until ($in eq "\n" || $in =~ /^y/i) {
    exit(0) if ($in =~ /^n.*/i);
    print "Do you wish to proceed? [Y/n]";
    $in = <STDIN>;
}

    if (Win32::IsWinNT()) {
        Win32API::Registry::RegOpenKeyEx ( HKEY_LOCAL_MACHINE,
            'SYSTEM\CurrentcontrolSet\control\Session Manager\Environment',
            NULL, KEY_ALL_ACCESS, $hkey ) || exit(1);

        Win32API::Registry::RegQueryValueEx( $hkey, 'PATH', [], $type,
            $pathstring, [] ) || exit(1);
        $pathstring = "$path;". join(';', grep(!/namazu/i, split(/;/, $pathstring))). ";";
        Win32API::Registry::RegSetValueEx( $hkey, 'PATH', NULL, $type,
            $pathstring, length($pathstring) ) || exit(1);
            print "PATH environment variable was set.\nThe value of $pathstring was set.\n\n";

        Win32API::Registry::RegSetValueEx( $hkey, 'NAMAZURC', NULL, $type,
            $namazurcpath, length($namazurcpath) ) || exit(1);
            print "NAMAZURC environment variable was set.\n";
            print "The value of $namazurcpath was set.\n\n";
        Win32API::Registry::RegSetValueEx( $hkey, 'NAMAZULOCALEDIR', NULL, $type,
            $namazulocaledir, length($namazulocaledir) ) || exit(1);
            print "NAMAZULOCALEDIR environment variable was set.\n";
            print "The value of $namazulocaledir was set.\n\n";
        Win32API::Registry::RegSetValueEx( $hkey, 'MKNMZRC', NULL, $type,
            $mknmzrcpath, length($mknmzrcpath) ) || exit(1);
            print "MKNMZRC environment variable was set.\n";
            print "The value of $mknmzrcpath was set.\n\n";

        if (!$ENV{'HOME'}) {
        Win32API::Registry::RegSetValueEx( $hkey, 'HOME', NULL, $type,
            $home, length($home) ) || exit(1);
            print "HOME environment variable was set.\nThe value of $home was set.\n\n";
        }
        if (!$ENV{'LANG'}) {
        Win32API::Registry::RegSetValueEx( $hkey, 'LANG', NULL, $type,
            $lang, length($lang) ) || exit(1);
            print "LANG environment variable was set.\nThe value of $lang was set.\n\n";
        }
        if ($locale == "00000411") {
            if (!$ENV{'KANWADICTPATH'}) {
            Win32API::Registry::RegSetValueEx( $hkey, 'KANWADICTPATH', NULL, $type,
                $kanwadictpath, length($kanwadictpath) ) || exit(1);
                print "KANWADICTPATH environment variable was set.\n";
                print "The value of $kanwadictpath was set.\n\n";
            }
            if (!$ENV{'ITAIJIDICTPATH'}) {
            Win32API::Registry::RegSetValueEx( $hkey, 'ITAIJIDICTPATH', NULL, $type,
                $itaijidictpath, length($itaijidictpath) ) || exit(1);
                print "ITAIJIDICTPATH environment variable was set.\n";
                print "The value of $itaijidictpath was set.\n\n";
            }
        }
        Win32API::Registry::RegCloseKey( $hkey );
    } else {
        my $pathflag;
        my $namazurcpathflag;
        my $namazulocaledirflag;
        my $mknmzrcpathflag;
        my $homeflag;
        my $langflag;
        my $kanwadictpathflag;
        my $itaijidictpathflag;
        open (AUTOEXEC,"<$autoexecfile");
        @TMP = <AUTOEXEC>;
        close(AUTOEXEC);
        foreach (@TMP) {
            $pathflag = 1
                if (m/^\s*SET PATH=.*\Q$path\E.*/i);
            $namazurcpathflag = 1
                if (s/^(\s*SET NAMAZURC=).*/$1$namazurcpath/i);
            $namazulocaledirflag = 1
                if (s/^(\s*SET NAMAZULOCALEDIR=).*/$1$namazulocaledir/i);
            $mknmzrcpathflag = 1
                if (s/^(\s*SET MKNMZRC=).*/$1$mknmzrcpath/i);
            $homeflag = 1 if (m/^\s*SET HOME=.*/i);
            $langflag = 1 if (m/^\s*SET LANG=.*/i);
            $kanwadictpathflag = 1 if (m/^\s*SET KANWADICTPATH=.*/i);
            $itaijidictpathflag = 1 if (m/^\s*SET ITAIJIDICTPATH=.*/i);
        }
        $comment = "\nREM ###### Namazu for Win32 Environment variable setting";
        push (@TMP,"$comment\n")
            if ((!$pathflag) && (!$namazurcpathflag));
        if (!$pathflag) {
            push (@TMP,"SET PATH=$path;\"%PATH%\"\n");
            print "PATH environment variable was set.\nThe value of $path was set.\n\n";
        }
        if (!$namazurcpathflag) {
            push (@TMP,"SET NAMAZURC=$namazurcpath\n");
            print "NAMAZURC environment variable was set.\n";
            print "The value of $namazurcpath was set.\n\n";
        } else {
            print "NAMAZURC environment variable was replace.\n";
            print "The value of $namazurcpath was replace.\n\n";
        }
        if (!$namazulocaledirflag) {
            push (@TMP,"SET NAMAZULOCALEDIR=$namazulocaledir\n");
            print "NAMAZULOCALEDIR environment variable was set.\n";
            print "The value of $namazulocaledir was set.\n\n";
        } else {
            print "NAMAZULOCALEDIR environment variable was replace.\n";
            print "The value of $namazulocaledir was replace.\n\n";
        }
        if (!$mknmzrcpathflag) {
            push (@TMP,"SET MKNMZRC=$mknmzrcpath\n");
            print "MKNMZRC environment variable was set.\n";
            print "The value of $mknmzrcpath was set.\n\n";
        } else {
            print "MKNMZRC environment variable was replace.\n";
            print "The value of $mknmzrcpath was replace.\n\n";
        }

        if (!$homeflag) {
            push (@TMP,"SET HOME=$home\n");
            print "HOME environment variable was set.\nThe value of $home was set.\n\n";
        }
        if (!$langflag) {
            push (@TMP,"SET LANG=$lang\n");
            print "LANG environment variable was set.\nThe value of $lang was set.\n\n";
        }
        if ($locale == "00000411") {
            $comment = "\nREM ###### kakasi for Win32 Environment variable setting";
            push (@TMP,"$comment\n")
                if ((!$kanwadictpathflag) && (!$itaijidictpathflag));
            if (!$kanwadictpathflag) {
                push (@TMP,"SET KANWADICTPATH=$kanwadictpath\n");
                print "KANWADICTPATH environment variable was set.\n";
                print "The value of $kanwadictpath was set.\n\n";
            }
            if (!$itaijidictpathflag) {
                push (@TMP,"SET ITAIJIDICTPATH=$itaijidictpath\n");
                print "ITAIJIDICTPATH environment variable was set.\n";
                print "The value of $itaijidictpath was set.\n\n";
            }
        }
        open (AUTOEXEC,">$autoexecfile") || exit(1);
        print AUTOEXEC @TMP;
        close(AUTOEXEC);

#        open (CONFIG,"<$configfile");
#        @TMP = <CONFIG>;
#        close(CONFIG);
#        foreach (@TMP) {
#            $shellflag = 1
#                if (m/^\s*SHELL=.*/i);
#        }
#        if (!$shellflag) {
#            $commandcompath = $ENV{'COMSPEC'};
#            $commandcompath =~ s/command.com//i;
#            push (@TMP,"SHELL=$ENV{'COMSPEC'} $commandcompath \/E:1024 /P\n");
#            print "SHELL environment variable was set.\n";
#            print "The value of $ENV{'COMSPEC'} $commandcompath /E:1024 /P was set.\n\n";
#        }
#        open (CONFIG,">$configfile") || exit(1);
#        print CONFIG @TMP;
#        close(CONFIG);
    }

    open (NAMZURCFH,"<$namazurc-sample");
    @TMP = <NAMZURCFH>;
    close (NAMZURCFH);
    foreach (@TMP) {
        s/^#(Index\s+).*/$1$indexpath/;
#        s/^#(Template\s+).*/$1$templatepath/;
        s/^#(Lang\s+).*/$1$lang/;
    }
    open (NAMZURCFH,">$namazurc-sample.win32") || exit(1);
    print NAMZURCFH @TMP;
    close (NAMZURCFH);
    print "$namazurc-sample.win32 file was made.\n\n";
    unless (-f $namazurc) {
        open (NAMZURCFH,">$namazurc") || exit(1);
        print NAMZURCFH @TMP;
        close (NAMZURCFH);
        print "$namazurc file was made.\n\n";
    }

    $confdirpath     =~ s/\\/\//g;
    $libdirpath      =~ s/\\/\//g;
    $filterdirpath   =~ s/\\/\//g;
    $templatedirpath =~ s/\\/\//g;
    open (MKNMZRCFH,"<$mknmzrc-sample");
    @TMP = <MKNMZRCFH>;
    close (MKNMZRCFH);
    foreach (@TMP) {
        s/^# (\$CONFDIR).*/$1 = \'$confdirpath\'\;/;
        s/^# (\$LIBDIR).*/$1 = \'$libdirpath\'\;/;
        s/^# (\$FILTERDIR).*/$1 = \'$filterdirpath\'\;/;
        s/^# (\$TEMPLATEDIR).*/$1 = \'$templatedirpath\'\;/;
    }
    open (MKNMZRCFH,">$mknmzrc-sample.win32") || exit(1);
    print MKNMZRCFH @TMP;
    close (MKNMZRCFH);
    print "$mknmzrc-sample.win32 file was made.\n\n";
    unless (-f $mknmzrc) {
        open (MKNMZRCFH,">$mknmzrc") || exit(1);
        print MKNMZRCFH @TMP;
        close (MKNMZRCFH);
        print "$mknmzrc file was made.\n\n";
    }

    if (-d "namazu") {
        chdir ("namazu");
        print "Change directory to namazu.\n\n";
    }

    foreach (@scripts) {system ("PL2BAT.BAT bin\\$_");}
 
#    if ($^V and $^V gt v5.6.0) {
    if ($] lt 5.006) {
        chdir ("obsolete");
        print "Change directory to obsolete.\n\n";
    }
    
    system ("PPM.BAT install File-MMagic.ppd");
    if ($locale == "00000411") {
        system ("PPM.BAT install Text-Kakasi.ppd");
        system ("PPM.BAT install NKF.ppd");
    }

unlink "namazu/share/namazu/filter/olemsword.pl" if -f "namazu/share/namazu/filter/olemsword.pl";
unlink "namazu/share/namazu/filter/oleexcel.pl" if -f "namazu/share/namazu/filter/oleexcel.pl";
unlink "namazu/share/namazu/filter/olepowerpoint.pl" if -f "namazu/share/namazu/filter/olepowerpoint.pl";
unlink "namazu/share/namazu/filter/ichitaro456.pl" if -f "namazu/share/namazu/filter/ichitaro456.pl";

0
__END__

:PERLNOTFOUND
@ECHO OFF
ECHO --------------------------------------------
ECHO   I can not found perl.exe.
ECHO   Or your perl.exe is old.
ECHO   Please install ActivePerl.
ECHO --------------------------------------------
GOTO DISPERROR

:CANNOTOPEN
ECHO --------------------------------------------
ECHO   I can not modify AUTOEXEC.BAT or Registry.
ECHO --------------------------------------------

:DISPERROR
IF NOT EXIST ERROR.TXT GOTO NOERRORTXT
START .\README.txt
START .\ERROR.txt
GOTO ERROROCCURRED

:NOERRORTXT
START .\namazu\README.txt
START .\namazu\ERROR.txt

:ERROROCCURRED
PAUSE

:END
ECHO ### Finish !!!
rem pause