#!/bin/sh

CURDIR=`pwd`
LOGFILE="$CURDIR/"`echo $0 | sed -e 's,.*/,,g'`".txt"
date 2>&1 | tee $LOGFILE

export HOMEDRIVE=$SYSTEMDRIVE
if test "$HOMEDRIVE" = "" ; then
 export HOMEDRIVE="C:"
fi
export CYGHOMEDRIVE=`echo $HOMEDRIVE | tr 'A-Z' 'a-z' | sed -e 's,^\([a-z]\):,/cygdrive/\1,'`
export PREFIX=$CYGHOMEDRIVE/mingw

export PREFIX=/mingw
export TARGET=`gcc -dumpmachine`


ARC=m4-1.4.tar.gz
if test -d m4 ; then
 cd m4
fi
BLD=`echo $ARC | sed -e 's/\.tar\.gz$//;s/\.tgz$//; s/\.tar\.bz2$//;s/\.tbz$//; s/\.tar\.Z$//;s/\.tz$//; s/\.gz$//; s/\.bz2$//; s/\.Z$//; s/\.zip$//; s/\.lzh$//; s/\.shar$//;'`
tar xvzf $ARC
cd $BLD
  if test -f ../$BLD-win32.patch ; then
   patch -p1 -f < ../$BLD-win32.patch 2>&1 | tee -a $LOGFILE
  fi
  ./configure --host=$TARGET --prefix=$PREFIX 2>&1 | tee -a $LOGFILE
  echo "==> make $BLD" 2>&1 | tee -a $LOGFILE
  find ./ -name '.deps' -type d | xargs rm -rf
  make 2>&1 | tee -a $LOGFILE
  make check 2>&1 | tee -a $LOGFILE
  echo "==> install $BLD" 2>&1 | tee -a $LOGFILE
  find ./ -name '.deps' -type d | xargs rm -rf
  make install 2>&1 | tee -a $LOGFILE
cd $CURDIR

ARC=autoconf-2.13.tar.gz
if test -d autoconf ; then
 cd autoconf
fi
BLD=`echo $ARC | sed -e 's/\.tar\.gz$//;s/\.tgz$//; s/\.tar\.bz2$//;s/\.tbz$//; s/\.tar\.Z$//;s/\.tz$//; s/\.gz$//; s/\.bz2$//; s/\.Z$//; s/\.zip$//; s/\.lzh$//; s/\.shar$//;'`
tar xvzf $ARC
cd $BLD
  if test -f ../$BLD-win32.patch ; then
   patch -p1 -f < ../$BLD-win32.patch 2>&1 | tee -a $LOGFILE
  fi
  ./configure --host=$TARGET --prefix=$PREFIX 2>&1 | tee -a $LOGFILE
  echo "==> make $BLD" 2>&1 | tee -a $LOGFILE
  find ./ -name '.deps' -type d | xargs rm -rf
  make 2>&1 | tee -a $LOGFILE
  make check 2>&1 | tee -a $LOGFILE
  echo "==> install $BLD" 2>&1 | tee -a $LOGFILE
  find ./ -name '.deps' -type d | xargs rm -rf
  make install 2>&1 | tee -a $LOGFILE
cd $CURDIR

ARC=automake-1.4.tar.gz
if test -d automake ; then
 cd automake
fi
BLD=`echo $ARC | sed -e 's/\.tar\.gz$//;s/\.tgz$//; s/\.tar\.bz2$//;s/\.tbz$//; s/\.tar\.Z$//;s/\.tz$//; s/\.gz$//; s/\.bz2$//; s/\.Z$//; s/\.zip$//; s/\.lzh$//; s/\.shar$//;'`
tar xvzf $ARC
cd $BLD
  if test -f ../$BLD-win32.patch ; then
   patch -p1 -f < ../$BLD-win32.patch 2>&1 | tee -a $LOGFILE
  fi
  aclocal -I m4 2>&1 | tee -a $LOGFILE
  autoconf 2>&1 | tee -a $LOGFILE
  ./configure --host=$TARGET --prefix=$PREFIX 2>&1 | tee -a $LOGFILE
  echo "==> make $BLD" 2>&1 | tee -a $LOGFILE
  find ./ -name '.deps' -type d | xargs rm -rf
  make 2>&1 | tee -a $LOGFILE
  make check 2>&1 | tee -a $LOGFILE
  echo "==> install $BLD" 2>&1 | tee -a $LOGFILE
  find ./ -name '.deps' -type d | xargs rm -rf
  make install 2>&1 | tee -a $LOGFILE
cd $CURDIR

ARC=libtool-1.3.5.tar.gz
if test -d libtool ; then
 cd libtool
fi
BLD=`echo $ARC | sed -e 's/\.tar\.gz$//;s/\.tgz$//; s/\.tar\.bz2$//;s/\.tbz$//; s/\.tar\.Z$//;s/\.tz$//; s/\.gz$//; s/\.bz2$//; s/\.Z$//; s/\.zip$//; s/\.lzh$//; s/\.shar$//;'`
tar xvzf $ARC
cd $BLD
  if test -f ../$BLD-win32.patch ; then
   patch -p1 -f < ../$BLD-win32.patch 2>&1 | tee -a $LOGFILE
  fi
  stou.sh ltmain.in
  stou.sh ltmain.sh
  aclocal 2>&1 | tee -a $LOGFILE
  autoheader 2>&1 | tee -a $LOGFILE
  automake --add-missing --copy 2>&1 | tee -a $LOGFILE
  autoconf 2>&1 | tee -a $LOGFILE
  ./configure --host=$TARGET --prefix=$PREFIX 2>&1 | tee -a $LOGFILE
  echo "==> make $BLD" 2>&1 | tee -a $LOGFILE
  find ./ -name '.deps' -type d | xargs rm -rf
  make 2>&1 | tee -a $LOGFILE
  make check 2>&1 | tee -a $LOGFILE
  echo "==> install $BLD" 2>&1 | tee -a $LOGFILE
  find ./ -name '.deps' -type d | xargs rm -rf
  make install 2>&1 | tee -a $LOGFILE
cd $CURDIR

ARC=gettext-0.10.35.tar.gz
if test -d gettext ; then
 cd gettext
fi
BLD=`echo $ARC | sed -e 's/\.tar\.gz$//;s/\.tgz$//; s/\.tar\.bz2$//;s/\.tbz$//; s/\.tar\.Z$//;s/\.tz$//; s/\.gz$//; s/\.bz2$//; s/\.Z$//; s/\.zip$//; s/\.lzh$//; s/\.shar$//;'`
tar xvzf $ARC
cd $BLD
  if test -f ../$BLD-win32.patch ; then
   patch -p1 -f < ../$BLD-win32.patch 2>&1 | tee -a $LOGFILE
  fi
  libtoolize --force --copy 2>&1 | tee -a $LOGFILE
  aclocal 2>&1 | tee -a $LOGFILE
  autoheader 2>&1 | tee -a $LOGFILE
  automake --add-missing --copy 2>&1 | tee -a $LOGFILE
  autoconf 2>&1 | tee -a $LOGFILE
  ./configure --host=$TARGET --prefix=$PREFIX -with-included-gettext 2>&1 | tee -a $LOGFILE
  echo "==> make $BLD" 2>&1 | tee -a $LOGFILE
  find ./ -name '.deps' -type d | xargs rm -rf
  make 2>&1 | tee -a $LOGFILE
  make check 2>&1 | tee -a $LOGFILE
  echo "==> install $BLD" 2>&1 | tee -a $LOGFILE
  find ./ -name '.deps' -type d | xargs rm -rf
  make install 2>&1 | tee -a $LOGFILE
cd $CURDIR

if test ! "$1" = "all" ; then
 exit
fi
###################################################################################

ARC=bzip2-1.0.1.tar.gz
if test -d bzip2 ; then
 cd bzip2
fi
BLD=`echo $ARC | sed -e 's/\.tar\.gz$//;s/\.tgz$//; s/\.tar\.bz2$//;s/\.tbz$//; s/\.tar\.Z$//;s/\.tz$//; s/\.gz$//; s/\.bz2$//; s/\.Z$//; s/\.zip$//; s/\.lzh$//; s/\.shar$//;'`
tar xvzf $ARC
cd $BLD
  if test -f ../$BLD-win32.patch ; then
   patch -p1 -f < ../$BLD-win32.patch 2>&1 | tee -a $LOGFILE
  fi
  echo "==> make $BLD" 2>&1 | tee -a $LOGFILE
  find ./ -name '.deps' -type d | xargs rm -rf
  make PREFIX=$PREFIX 2>&1 | tee -a $LOGFILE
  echo "==> install $BLD" 2>&1 | tee -a $LOGFILE
  find ./ -name '.deps' -type d | xargs rm -rf
  make PREFIX=$PREFIX install 2>&1 | tee -a $LOGFILE
cd $CURDIR

ARC=gzip-1.2.4a.tar.gz
if test -d gzip ; then
 cd gzip
fi
BLD=`echo $ARC | sed -e 's/\.tar\.gz$//;s/\.tgz$//; s/\.tar\.bz2$//;s/\.tbz$//; s/\.tar\.Z$//;s/\.tz$//; s/\.gz$//; s/\.bz2$//; s/\.Z$//; s/\.zip$//; s/\.lzh$//; s/\.shar$//;'`
tar xvzf $ARC
cd $BLD
  if test -f ../$BLD-win32.patch ; then
   patch -p1 -f < ../$BLD-win32.patch 2>&1 | tee -a $LOGFILE
  fi
  ./configure --host=$TARGET --prefix=$PREFIX 2>&1 | tee -a $LOGFILE
  echo "==> make $BLD" 2>&1 | tee -a $LOGFILE
  find ./ -name '.deps' -type d | xargs rm -rf
  make 2>&1 | tee -a $LOGFILE
  make check 2>&1 | tee -a $LOGFILE
  echo "==> install $BLD" 2>&1 | tee -a $LOGFILE
  find ./ -name '.deps' -type d | xargs rm -rf
  make install 2>&1 | tee -a $LOGFILE
cd $CURDIR

ARC=tar-1.13.tar.gz
if test -d tar ; then
 cd tar
fi
BLD=`echo $ARC | sed -e 's/\.tar\.gz$//;s/\.tgz$//; s/\.tar\.bz2$//;s/\.tbz$//; s/\.tar\.Z$//;s/\.tz$//; s/\.gz$//; s/\.bz2$//; s/\.Z$//; s/\.zip$//; s/\.lzh$//; s/\.shar$//;'`
tar xvzf $ARC
cd $BLD
  if test -f ../$BLD-win32.patch ; then
   patch -p1 -f < ../$BLD-win32.patch 2>&1 | tee -a $LOGFILE
  fi
  ./configure --host=$TARGET --prefix=$PREFIX 2>&1 | tee -a $LOGFILE
  echo "==> make $BLD" 2>&1 | tee -a $LOGFILE
  find ./ -name '.deps' -type d | xargs rm -rf
  make 2>&1 | tee -a $LOGFILE
  make check 2>&1 | tee -a $LOGFILE
  echo "==> install $BLD" 2>&1 | tee -a $LOGFILE
  find ./ -name '.deps' -type d | xargs rm -rf
  make install 2>&1 | tee -a $LOGFILE
cd $CURDIR

ARC=sharutils-4.2.tar.gz
if test -d sharutils ; then
 cd sharutils
fi
BLD=`echo $ARC | sed -e 's/\.tar\.gz$//;s/\.tgz$//; s/\.tar\.bz2$//;s/\.tbz$//; s/\.tar\.Z$//;s/\.tz$//; s/\.gz$//; s/\.bz2$//; s/\.Z$//; s/\.zip$//; s/\.lzh$//; s/\.shar$//;'`
tar xvzf $ARC
cd $BLD
  if test -f ../$BLD-win32.patch ; then
   patch -p1 -f < ../$BLD-win32.patch 2>&1 | tee -a $LOGFILE
  fi
  ./configure --host=$TARGET --prefix=$PREFIX 2>&1 | tee -a $LOGFILE
  echo "==> make $BLD" 2>&1 | tee -a $LOGFILE
  find ./ -name '.deps' -type d | xargs rm -rf
  make 2>&1 | tee -a $LOGFILE
  make check 2>&1 | tee -a $LOGFILE
  echo "==> install $BLD" 2>&1 | tee -a $LOGFILE
  find ./ -name '.deps' -type d | xargs rm -rf
  make install 2>&1 | tee -a $LOGFILE
cd $CURDIR

ARC=patch-2.5.4.tar.gz
if test -d patch ; then
 cd patch
fi
BLD=`echo $ARC | sed -e 's/\.tar\.gz$//;s/\.tgz$//; s/\.tar\.bz2$//;s/\.tbz$//; s/\.tar\.Z$//;s/\.tz$//; s/\.gz$//; s/\.bz2$//; s/\.Z$//; s/\.zip$//; s/\.lzh$//; s/\.shar$//;'`
tar xvzf $ARC
cd $BLD
  if test -f ../$BLD-win32.patch ; then
   patch -p1 -f < ../$BLD-win32.patch 2>&1 | tee -a $LOGFILE
  fi
  ./configure --host=$TARGET --prefix=$PREFIX 2>&1 | tee -a $LOGFILE
  echo "==> make $BLD" 2>&1 | tee -a $LOGFILE
  find ./ -name '.deps' -type d | xargs rm -rf
  make 2>&1 | tee -a $LOGFILE
  make check 2>&1 | tee -a $LOGFILE
  echo "==> install $BLD" 2>&1 | tee -a $LOGFILE
  find ./ -name '.deps' -type d | xargs rm -rf
  make install 2>&1 | tee -a $LOGFILE
cd $CURDIR

ARC=make-3.79.1.tar.gz
if test -d make ; then
 cd make
fi
BLD=`echo $ARC | sed -e 's/\.tar\.gz$//;s/\.tgz$//; s/\.tar\.bz2$//;s/\.tbz$//; s/\.tar\.Z$//;s/\.tz$//; s/\.gz$//; s/\.bz2$//; s/\.Z$//; s/\.zip$//; s/\.lzh$//; s/\.shar$//;'`
tar xvzf $ARC
cd $BLD
  if test -f ../$BLD-win32.patch ; then
   patch -p1 -f < ../$BLD-win32.patch 2>&1 | tee -a $LOGFILE
  fi
  ./configure --host=$TARGET --prefix=$PREFIX 2>&1 | tee -a $LOGFILE
  echo "==> make $BLD" 2>&1 | tee -a $LOGFILE
  find ./ -name '.deps' -type d | xargs rm -rf
  make 2>&1 | tee -a $LOGFILE
  make check 2>&1 | tee -a $LOGFILE
  echo "==> install $BLD" 2>&1 | tee -a $LOGFILE
  find ./ -name '.deps' -type d | xargs rm -rf
  ./make install 2>&1 | tee -a $LOGFILE
cd $CURDIR

ARC=zlib-1.1.3.tar.gz
if test -d zlib ; then
 cd zlib
fi
BLD=`echo $ARC | sed -e 's/\.tar\.gz$//;s/\.tgz$//; s/\.tar\.bz2$//;s/\.tbz$//; s/\.tar\.Z$//;s/\.tz$//; s/\.gz$//; s/\.bz2$//; s/\.Z$//; s/\.zip$//; s/\.lzh$//; s/\.shar$//;'`
tar xvzf $ARC
cd $BLD
  if test -f ../$BLD-win32.patch ; then
   patch -p1 -f < ../$BLD-win32.patch 2>&1 | tee -a $LOGFILE
  fi
  ./configure --host=$TARGET --prefix=$PREFIX 2>&1 | tee -a $LOGFILE
  echo "==> make $BLD" 2>&1 | tee -a $LOGFILE
  find ./ -name '.deps' -type d | xargs rm -rf
  make 2>&1 | tee -a $LOGFILE
  make check 2>&1 | tee -a $LOGFILE
  echo "==> install $BLD" 2>&1 | tee -a $LOGFILE
  find ./ -name '.deps' -type d | xargs rm -rf
  make install 2>&1 | tee -a $LOGFILE
cd $CURDIR

ARC=glib-1.2.8.tar.gz
if test -d glib ; then
 cd glib
fi
BLD=`echo $ARC | sed -e 's/\.tar\.gz$//;s/\.tgz$//; s/\.tar\.bz2$//;s/\.tbz$//; s/\.tar\.Z$//;s/\.tz$//; s/\.gz$//; s/\.bz2$//; s/\.Z$//; s/\.zip$//; s/\.lzh$//; s/\.shar$//;'`
tar xvzf $ARC
cd $BLD
  if test -f ../$BLD-win32.patch ; then
   patch -p1 -f < ../$BLD-win32.patch 2>&1 | tee -a $LOGFILE
  fi
  ./configure --host=$TARGET --prefix=$PREFIX 2>&1 | tee -a $LOGFILE
  echo "==> make $BLD" 2>&1 | tee -a $LOGFILE
  find ./ -name '.deps' -type d | xargs rm -rf
  make 2>&1 | tee -a $LOGFILE
  make check 2>&1 | tee -a $LOGFILE
  echo "==> install $BLD" 2>&1 | tee -a $LOGFILE
  find ./ -name '.deps' -type d | xargs rm -rf
  make install 2>&1 | tee -a $LOGFILE
cd $CURDIR

ARC=guile-1.4.tar.gz
if test -d guile ; then
 cd guile
fi
BLD=`echo $ARC | sed -e 's/\.tar\.gz$//;s/\.tgz$//; s/\.tar\.bz2$//;s/\.tbz$//; s/\.tar\.Z$//;s/\.tz$//; s/\.gz$//; s/\.bz2$//; s/\.Z$//; s/\.zip$//; s/\.lzh$//; s/\.shar$//;'`
tar xvzf $ARC
cd $BLD
  if test -f ../$BLD-win32.patch ; then
   patch -p1 -f < ../$BLD-win32.patch 2>&1 | tee -a $LOGFILE
  fi
  ./configure --host=$TARGET --prefix=$PREFIX 2>&1 | tee -a $LOGFILE
  echo "==> make $BLD" 2>&1 | tee -a $LOGFILE
  find ./ -name '.deps' -type d | xargs rm -rf
  make 2>&1 | tee -a $LOGFILE
  make check 2>&1 | tee -a $LOGFILE
  echo "==> install $BLD" 2>&1 | tee -a $LOGFILE
  find ./ -name '.deps' -type d | xargs rm -rf
  make install 2>&1 | tee -a $LOGFILE
cd $CURDIR

