#!/bin/sh

CURDIR=`pwd`
LOGFILE="$CURDIR/"`echo $0 | sed -e 's,.*/,,g'`".txt"
date 2>&1 | tee $LOGFILE

ARC=nkf171.shar

if test -d nkf ; then
 cd nkf
fi
BLD=`echo $ARC | sed -e 's/\.tar\.gz$//;s/\.tgz$//; s/\.tar\.bz2$//;s/\.tbz$//; s/\.tar\.Z$//;s/\.tz$//; s/\.gz$//; s/\.bz2$//; s/\.Z$//; s/\.zip$//; s/\.lzh$//; s/\.shar$//;'`
mkdir -p $BLD
cd $BLD
sh ../$ARC

export PREFIX=/nkf
export TARGET=`gcc -dumpmachine`

cp -f nkf.c nkf.c.$$
mv -f nkf.c.$$ nkf.c
make CC=gcc 2>&1 | tee -a $LOGFILE

mkdir -p $PREFIX
cp -f ../$ARC $PREFIX
mkdir -p $PREFIX/bin
install -c nkf.exe $PREFIX/bin

strip $PREFIX/bin/nkf.exe

mkdir -p $PREFIX/man/man1
cp -f nkf.1 $PREFIX/man/man1
mkdir -p $PREFIX/man/ja/man1
cp -f nkf.1j $PREFIX/man/ja/man1/nkf.1
mkdir -p $PREFIX/doc
cp -f nkf.doc $PREFIX/doc

sed -e "s/..//g" -e "s/.//g" nkf.doc > nkf.doc.TEMPFILE
nkf -J -s -O nkf.doc.TEMPFILE $PREFIX/nkf.sjis
rm -f $PREFIX/nkf.doc.TEMPFILE

if test -z "`type cl 2>&1 | grep 'not found'`" ; then
    SYSLIBS=`echo -L$LIB | sed -e "s/\;$//" -e "s/\;/ -L/g"`
 if test -d NKF ; then
  cd NKF
  perl Makefile.PL 2>&1 | tee -a $LOGFILE
  nmake 2>&1 | tee -a $LOGFILE
  nmake test 2>&1 | tee -a $LOGFILE
  tar cvzf NKF.tar.gz blib/*
  mv -f NKF.tar.gz ../
  nmake ppd 2>&1 | tee -a $LOGFILE
  sed -e 's#<ABSTRACT></ABSTRACT>#<ABSTRACT>NKF library module for perl</ABSTRACT>#' -e 's#<AUTHOR></AUTHOR>#<AUTHOR>Ken-ichi Hirose \&lt;kenzo-@tama.or.jp\&gt;</AUTHOR>#' -e 's#<CODEBASE HREF="" />#<CODEBASE HREF="x86/NKF.tar.gz" />#' NKF.ppd > NKF.ppd.TEMPFILE
  mv -f NKF.ppd.TEMPFILE NKF.ppd
  mv -f NKF.ppd ../
  cd ..
 fi
fi

if test -f NKF.tar.gz ; then
 mkdir -p $PREFIX/x86
 mv -f NKF.tar.gz $PREFIX/x86
 mv -f NKF.ppd $PREFIX
fi

cd $CURDIR

