#!/bin/sh

CURDIR=`pwd`
LOGFILE="$CURDIR/"`echo $0 | sed -e 's,.*/,,g'`".txt"
date 2>&1 | tee $LOGFILE

ARC=namazu-2.0.5.tar.gz

if test -d namazu ; then
 cd namazu
fi
BLD=`echo $ARC | sed -e 's/\.tar\.gz$//;s/\.tgz$//; s/\.tar\.bz2$//;s/\.tbz$//; s/\.tar\.Z$//;s/\.tz$//; s/\.gz$//; s/\.bz2$//; s/\.Z$//; s/\.zip$//; s/\.lzh$//; s/\.shar$//;'`
BLD=`echo $BLD | sed -e 's/\(namazu\-[0-9]\.[0-9]\.[0-9]\)\(.*\)$/\1/;'`
tar xvzf $ARC
cd $BLD

export PREFIX=/namazu
export TARGET=`gcc -dumpmachine`

export ac_cv_prog_LN_S=ln

export ac_cv_path_LYNX=lynx
export ac_cv_path_GROFF=groff
export ac_cv_path_INFO=info
export ac_cv_path_ZCAT=zcat
export ac_cv_path_NETSCAPE=netscape
export ac_cv_path_WISH=/tcl/bin/wish42jp
export ac_cv_path_EMACS=/meadow/1.0/bin/meadow

cd File-MMagic
perl Makefile.PL 2>&1 | tee -a $LOGFILE
nmake 2>&1 | tee -a $LOGFILE
nmake test 2>&1 | tee -a $LOGFILE
nmake install 2>&1 | tee -a $LOGFILE
tar cvzf File-MMagic.tar.gz blib/*
mv -f File-MMagic.tar.gz ../
nmake ppd 2>&1 | tee -a $LOGFILE
sed -e 's#<ABSTRACT></ABSTRACT>#<ABSTRACT>Guess file type from contents</ABSTRACT>#' -e 's#<AUTHOR></AUTHOR>#<AUTHOR>NOKUBI Takatsugu \&lt;knok@daionet.gr.jp\&gt;</AUTHOR>#' -e 's#<CODEBASE HREF="" />#<CODEBASE HREF="x86/File-MMagic.tar.gz" />#' File-MMagic.ppd > File-MMagic.ppd.TEMPFILE
mv -f File-MMagic.ppd.TEMPFILE File-MMagic.ppd
mv -f File-MMagic.ppd ../
cd ..

libtoolize --force --copy 2>&1 | tee -a $LOGFILE
aclocal 2>&1 | tee -a $LOGFILE
autoheader 2>&1 | tee -a $LOGFILE
automake 2>&1 | tee -a $LOGFILE
autoconf 2>&1 | tee -a $LOGFILE
if test -e autogen.sh ; then
 ./autogen.sh --prefix=$PREFIX --host=$TARGET --enable-shared=no 2>&1 | tee -a $LOGFILE
fi
./configure --prefix=$PREFIX --host=$TARGET --enable-shared=no --enable-tknamazu $* 2>&1 | tee -a $LOGFILE
if test -e intl/libintl.h ; then
 rm -f intl/libintl.h
 ln intl/libgettext.h intl/libintl.h
fi

sed -e "s/^\$ADDRESS = 'webmaster@.*$/\$ADDRESS = 'webmaster@foo.bar.jp';/" pl/conf.pl > pl/conf.pl.TEMPFILE
mv -f pl/conf.pl.TEMPFILE pl/conf.pl
sed -e "s/^<link rev=made href=\"mailto:webmaster@.*$/<link rev=made href=\"mailto:webmaster@foo.bar.jp\">/" template/NMZ.head > template/NMZ.head.TEMPFILE
mv -f template/NMZ.head.TEMPFILE template/NMZ.head
sed -e "s/^<a href=\"mailto:webmaster@.*$/<a href=\"mailto:webmaster@foo.bar.jp\">/" template/NMZ.foot > template/NMZ.foot.TEMPFILE
mv -f template/NMZ.foot.TEMPFILE template/NMZ.foot
sed -e "s/^<link rev=made href=\"mailto:webmaster@.*$/<link rev=made href=\"mailto:webmaster@foo.bar.jp\">/" template/NMZ.head.ja > template/NMZ.head.ja.TEMPFILE
mv -f template/NMZ.head.ja.TEMPFILE template/NMZ.head.ja
sed -e "s/^<a href=\"mailto:webmaster@.*$/<a href=\"mailto:webmaster@foo.bar.jp\">/" template/NMZ.foot.ja > template/NMZ.foot.ja.TEMPFILE
mv -f template/NMZ.foot.ja.TEMPFILE template/NMZ.foot.ja

make OPT_ADMIN_EMAIL=webmaster@foo.bar.jp 2>&1 | tee -a $LOGFILE
make OPT_ADMIN_EMAIL=webmaster@foo.bar.jp check 2>&1 | tee -a $LOGFILE
make OPT_ADMIN_EMAIL=webmaster@foo.bar.jp install 2>&1 | tee -a $LOGFILE

strip $PREFIX/bin/namazu.exe
strip $PREFIX/libexec/namazu.cgi.exe

touch $PREFIX/var/namazu/index/dummy

cd lisp
make 2>&1 | tee -a $LOGFILE
mkdir -p $PREFIX/share/site-lisp/namazu
install -c namazu.el $PREFIX/share/site-lisp/namazu/namazu.el
GNUSNMZ=`ls gnus-nmz*.el`
install -c $GNUSNMZ $PREFIX/share/site-lisp/namazu/$GNUSNMZ
BROWSEURL=`ls browse-url-for-emacs*.el`
install -c $BROWSEURL $PREFIX/share/site-lisp/namazu/$BROWSEURL
cd ..

if test -z "`type cl 2>&1 | grep 'not found'`" ; then
 rm -f config.cache
 CC="cl -nologo -Gf -W3 -O1 -MD" LD="lib -nologo" ./configure --prefix=$PREFIX --host=i386-windows --enable-shared=no --disable-nls
 
 cd lib
 make clean 2>&1 | tee -a $LOGFILE
 make all 2>&1 | tee -a $LOGFILE
## if test -f nmz.def ; then
##  nmake -f makefile.msc 2>&1 | tee -a $LOGFILE
## else
  OBJS=`ls *.obj`
  lib -nologo -OUT:libnmzut.lib $OBJS
## fi
 cd ..
 
 cd nmz
 make clean 2>&1 | tee -a $LOGFILE
 make all 2>&1 | tee -a $LOGFILE
## if test -f nmz.def ; then
##  nmake -f makefile.msc 2>&1 | tee -a $LOGFILE
##  mkdir -p $PREFIX/lib
##  cp -f libnmz.lib $PREFIX/lib
##  cp -f nmz.lib nmz.dll $PREFIX/lib
## else
  OBJS=`ls *.obj`
  lib -nologo -OUT:libnmz.lib $OBJS
  mkdir -p $PREFIX/lib
  cp -f libnmz.lib $PREFIX/lib
  echo "LIBRARY \"nmz\"" > nmz.def
  echo "EXPORTS" >> nmz.def
  for F in $OBJS; do
   nm $F | grep 'T _' | sed 's/.* T _/ /' >> nmz.def
  done
  cp -f ../lib/libnmzut.lib .
  cl -nologo -Gf -W3 -O1 -MD -LD -Fenmz.dll $OBJS libnmzut.lib -link -def:nmz.def
  mkdir -p $PREFIX/lib
  cp -f nmz.lib nmz.dll $PREFIX/lib
  rm -f *.def
## fi
 cd ..
 
 SYSLIBS=`echo -L$LIB | sed -e "s/\;$//" -e "s/\;/ -L/g"`
 if test -d Search-Namazu ; then
  cd Search-Namazu
  perl Makefile.PL LIBS="-L../nmz -llibnmz -L../lib -llibnmzut $SYSLIBS" 2>&1 | tee -a $LOGFILE
  nmake 2>&1 | tee -a $LOGFILE
  nmake test 2>&1 | tee -a $LOGFILE
  tar cvzf Search-Namazu.tar.gz blib/*
  mv -f Search-Namazu.tar.gz ../
  nmake ppd 2>&1 | tee -a $LOGFILE
  sed -e 's#<ABSTRACT></ABSTRACT>#<ABSTRACT>Namazu library module for perl</ABSTRACT>#' -e 's#<AUTHOR></AUTHOR>#<AUTHOR>NOKUBI Takatsugu \&lt;knok@daionet.gr.jp\&gt;</AUTHOR>#' -e 's#<CODEBASE HREF="" />#<CODEBASE HREF="x86/Search-Namazu.tar.gz" />#' Search-Namazu.ppd > Search-Namazu.ppd.TEMPFILE
  mv -f Search-Namazu.ppd.TEMPFILE Search-Namazu.ppd
  mv -f Search-Namazu.ppd ../
  cd ..
 fi
 
 cd lib
 rm -f *.obj
 rm -f *.lib
 rm -f *.exp
 rm -f *.dll
 rm -f .libs/*.lib
 cd ..
 
 cd nmz
 rm -f *.obj
 rm -f *.lib
 rm -f *.exp
 rm -f *.dll
 rm -f .libs/*.lib
 cd ..
 
 unset OBJS
 unset SYSLIBS
 rm -f config.cache
 make clean 2>&1 | tee -a $LOGFILE
fi
make clean 2>&1 | tee -a $LOGFILE

if test -f File-MMagic.tar.gz ; then
 mkdir -p $PREFIX/x86
 mv -f File-MMagic.tar.gz $PREFIX/x86
 mv -f File-MMagic.ppd $PREFIX
fi

if test -f Search-Namazu.tar.gz ; then
 mkdir -p $PREFIX/x86
 mv -f Search-Namazu.tar.gz $PREFIX/x86
 mv -f Search-Namazu.ppd $PREFIX
fi

cd $CURDIR

